<template>
  <div class="plot-chart-area d-flex flex-grow-1 flex-column">
    <!-- loading spinner -->
    <template v-if="loading">
      <div class="d-flex flex-grow-1">
        <div class="mx-auto my-4">
          <h2 class="text-center mt-4">A carregar...</h2>
          <span class="align-middle">
            <clip-loader :loading="loading" color="#007bff" size="50px" radius="100%"/>
          </span>
        </div>
      </div>
    </template>
    <template v-else>
      <div class="chart-container">
        <base-chart ref="chart" :styles="chartStyle()" :options="chartOptions" :chart-data="chartData"/>
      </div>
    </template>
  </div>
</template>

<script>
import moment from 'moment'
import ClipLoader from 'vue-spinner/src/ClipLoader'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import BaseChart from '@/core/charts/mixins/BaseChart'
import { DEFAULT_CHART_OPTIONS } from '@/plots/chart'
import plotSettings from '@/plots/settings'
import { getFeatureInfo, buildFeatureInfoRequestUrl } from '@/featureinfo/request'
import { getComponentsFromLayerName } from '@/featureinfo/process'

export default {
  name: 'plotchartarea',

  mixins: [
    WorkspaceGetter
  ],

  data() {
    return {
      loading: true
    }
  },

  computed: {
    query: {
      get() {
        return this.$store.getters.workspaceQuery(this.workspaceId)
      }
    },

    location: {
      get() {
        return this.$store.getters.workspaceLocationById(this.workspaceId, this.query.locationId)
      }
    },

    plotVariables: {
      get() {
        return this.$store.getters.workspaceCurrentPlotSettings(this.workspaceId)
      },
    },

    referenceTime: {
      get() {
        return this.$store.getters.workspaceReferenceTime(this.workspaceId)
      }
    },

    chartOptions: {
      get() {
        let options = {
          ...DEFAULT_CHART_OPTIONS,
        }

        options.scales.yAxes = this.plotVariables.map((plotVariable) => {
          return plotSettings.getAxisById(
            plotSettings.getSettingsForVariable(plotVariable).dataType.yAxisID
          )
        }).filter((axis, index, arr) => {
          return arr.indexOf(axis) === index
        }).map((axis, index) => {
          return {
            ...axis,
            position: index % 2 === 0 ? 'left' : 'right'
          }
        })

        return options
      }
    },
  },

  asyncComputed: {
    async chartData() {
      this.loading = true

      let datasets = []

      for(let i = 0; i < this.plotVariables.length; i++) {
        let plotVariable = this.plotVariables[i]

        let components = getComponentsFromLayerName(plotVariable)
        let layerName = `${components.model}.${components.name}`
        
        let url = buildFeatureInfoRequestUrl({
          layer: `${components.model}.${components.name}`,
          latitude: this.location.latitude,
          longitude: this.location.longitude,
          reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00[Z]'),
          time: [...Array(72).keys()].map(h => {
            return moment.unix(this.referenceTime).add(h, 'hour').format('YYYY-MM-DDTHH:00:00')
          })
        })

        try {
          let response = await getFeatureInfo(url)
        
          let data = response.data.properties[layerName]
            .filter(item => item.level.toLowerCase() === components.level)
          let plotData = plotSettings.getSettingsForVariable(plotVariable).process(data)

          datasets.push({
            ...plotSettings.getSettingsForVariable(plotVariable).dataType,
            data: plotData,
          })
        } catch(error) {
          window.console.log(error)
        }
      }

      this.loading = false

      return {
        datasets: datasets
      }
    }
  },

  watch: {
    chartOptions() {
      this.$refs.chart.getChartObject().update()
    }
  },

  methods: {
    chartStyle() {
      return { height: '300px', position: 'relative' }
    }
  },

  components: {
    BaseChart,
    ClipLoader,
  },
}
</script>

<style scoped>
.chart-container {
  display: block;
  position: relative;
  height: 300px;
  max-height: 300px;
  width: 100%;
}
</style>
